#!/bin/bash
# Sapacyfy the your current directory of the Url Black list
#URLBLDIR=/opt/safesquid/urlbl
URLBLDIR=/opt/safesquid/urlbl

# Define the on which directory you want to download the tarball pakge 
#DONLOADDIR=/usr/local/src
DOWNLOADDIR=/usr/local/download_urlbl

# Define the temprary work directores 
WORKDIR=/tmp/WORK
TMPDIR=/tmp/temwork
EXTRA=/tmp/EXTR
METRAC=/tmp/BACK
# Define the path of the tar command 
TARBIN=/bin/tar

CURRENTCATEGORY=`ls -l ${URLBLDIR} | awk '{print $9}'`
echo -e "These are the current categoris \033[1m ${CURRENTCATEGORY} \033[0m "

if	[ ! -d ${WORKDIR} ]; then 
echo "${WORKDIR} is not there i am creating "
mkdir ${WORKDIR}
echo "created ${WORKDIR} directory"  
fi


mkdir ${METRAC}

mkdir ${EXTRA}
mkdir ${TMPDIR}
mkdir -p ${DOWNLOADDIR}
cd ${DOWNLOADDIR}
# Put download url hear from which you would like to download the tarball packge
echo -e "\033[92m downloading the tar ball packge.... \033[0m in \033[1m ${DONLOADDIR} \033[0m "
export BL_URL=${BL_URL:="http://urlblacklist.com/cgi-bin/commercialdownload.pl?type=download&file=bigblacklist"}
 wget -q --no-proxy "${BL_URL}" -O bigblacklist.tar.gz
if [ $?  !=  0 ];then
	echo -e "\033[91m File can't able to download file please check internet connection.\033[0m  "
	exit 1
fi

echo -e " \033[92m Extracting the packge \033[0m "
${TARBIN} -xzvf bigblacklist.tar.gz -C ${TMPDIR}
NEWCATE=`ls -l ${TMPDIR}/blacklists | awk '{print $9}'`

echo -e "These are the new categoris \033[1m ${NEWCATE} \033[0m "
for i in ${NEWCATE}; do
cp -rf -v  ${TMPDIR}/blacklists/${i} ${EXTRA}
done

for i in ${CURRENTCATEGORY} ;do 
echo -e "copying \033[92m category $i \033[0m \tin \033[1m ${WORKDIR} \033[0m for work "
cp -rf ${TMPDIR}/blacklists/${i} ${WORKDIR}/
#sleep 2s
done 

for i in ${CURRENTCATEGORY}; do
cp -rf ${URLBLDIR}/${i} ${METRAC}/
OLDRCD=`wc -l  ${METRAC}/${i}/domains | awk '{print $1}'`
cat ${URLBLDIR}/${i}/domains ${WORKDIR}/${i}/domains | sort | uniq > ${WORKDIR}/${i}.presort
cat ${WORKDIR}/${i}.presort > ${URLBLDIR}/${i}/domains
NEWRCD=`wc -l ${URLBLDIR}/${i}/domains | awk '{print $1}'`
UPDATEDNU=`expr ${NEWRCD} - ${OLDRCD}`
echo -e "Category 			 : ${i} ">> /root/urlbl`date --date "today" +%d-%m-%Y`.report
#echo -e "Data before Upgradation 	 : ${OLDRCD}" >> /root/urlbl`date --date "today" +%d-%m-%Y`.report
#echo -e "Data changed during Upgradation  : `expr ${NEWRCD} - ${OLDRCD}`">> /root/urlbl`date --date "today" +%d-%m-%Y`.report
echo -e "New Records in Database 	 : ${NEWRCD}">> /root/urlbl`date --date "today" +%d-%m-%Y`.report
echo -e " ">> /root/urlbl`date --date "today" +%d-%m-%Y`.report
rm -rf ${WORKDIR}/${i}.presort
sleep 2s
done

for i in ${NEWCATE}; do
cp -rf ${EXTRA}/blacklists/${i} ${URLBLDIR}/
done

mv ${DOWNLOADDIR}/bigblacklist.tar.gz ${DOWNLOADDIR}/`date --date "today" +%d-%m-%Y%H:%M`.tar.gz
echo -e "\033[93m Removing the temperary Directory\n See the report below\033[0m "
rm -rf ${TMPDIR}
rm -rf ${WORKDIR}
rm -rf ${EXTRA}
cat /root/urlbl`date --date "today" +%d-%m-%Y`.report
# Uncomment following lines to restart the safesquid service 
/etc/init.d/safesquid stop
